#include "Expansion.h"

void Expansion::dec( Tree* t)
{
	char Buffer[10];
	const char* a_pointer = t->data.c_str();
	int num;
	num = atoi(a_pointer);
	num--;
	itoa( num, Buffer, 10);
	string str(Buffer);
	t->data = str;
}

// assume t->data=='^'

void Expansion::eliminatePower( Tree* t)
{
	// base case
	if (t->right->data == "1" )
	{
		delete(t->right);
		Tree* a = t->left;
		t->data = a->data;
		t->left = a->left;
		t->right= a->right;
		return;
	}
	Tree* a1 = copy( t->left );
	//---------- Making the new node ----------
	Tree* newNode = new Tree('^');
	newNode->left = a1;
	dec(t->right);
	newNode->right = t->right;
	//-----------------------------------------
	t->right = newNode;
	t->data = "*";
	return;
}

// gets a tree and make tree similar to it
Tree* Expansion::copy( Tree* t)
{
	if ( t == NULL) return NULL;
	Tree* T = new Tree( t->data );
	T->left = copy( t->left );
	T->right = copy( t->right );
	T->sign = t->sign;
	return T;
}

/*
		*                              +
	  /   \                          /   \
	 x	   +             ==\        *     *
          / \            ==/       / \   / \
         y   z                    x   y x   z
*/

void Expansion::rightExpand( Tree* t)
{
	char expandType = t->right->data[0];
	Tree* x1 = copy(t->left);
	Tree* x2 = t->left;
	Tree* y  = t->right->left;
	//----- Making the new node -----
	Tree* newNode = new Tree('*');
	newNode->left = x1;
	newNode->right= y;
	//-------------------------------
	t->left = newNode;
	t->right->left = x2;
	//------ Changing the datas ------
	t->data = expandType;
	t->right->data = "*";
	t->left->data  = "*";
}
	
/*
		*                              +
	  /   \                          /   \
     +     z       ==\              *     *
    / \            ==/             / \   / \
   x   y                          x   z y   z
*/

void Expansion::leftExpand( Tree* t)
{
	char expandType = t->left->data[0];
	Tree* z1 = copy(t->right);
	Tree* z2 = t->right;
	Tree* y  = t->left->right;
	//----- Making the new node -----
	Tree* newNode = new Tree('*');
	newNode->left = y;
	newNode->right= z1;
	//-------------------------------
	t->right = newNode;
	t->left->right = z2;
	//------ Changing the datas ------
	t->data = expandType;
	t->right->data = "*";
	t->left->data  = "*";
}

// It is assumed that t->data is '*'

void Expansion::checkExpand(Tree * t)
{
	bool isLeft =  ( t->left->data[0] == '+'  ) || ( t->left->data[0] == '-'  );
	bool isRight = ( t->right->data[0] == '+' ) || ( t->right->data[0] == '-' );

	if ( (t->data[0] == '*') && ( isRight ) )
		rightExpand(t);
	if ( (t->data[0] == '*') && ( isLeft ) )
		leftExpand(t);

}

int Expansion::MAX( int a, int b)
{
	return (a>b) ? a : b;
}

int Expansion::maxDepth( Tree* x)
{
	if (x!=NULL) return (1+MAX(maxDepth(x->left),maxDepth(x->right)));
	else return 0;
}

// Expands out products

void Expansion::PolyExpansion( Tree* head)
{
	Tree* cur;
	queue<Tree*> Q_tree;
	Q_tree.push(head);
	while( Q_tree.size() != 0 )
	{
		cur = Q_tree.front();
		Q_tree.pop();
		if ( cur != NULL )
		{
			if( cur->data[0] == '*' ) checkExpand(cur);
			Q_tree.push( cur->left  );
			Q_tree.push( cur->right );
		}
	}
}

void Expansion::changeSign( Tree* t)
{
	if ( t== NULL ) return;
	if (t->sign) t->sign = false;
	else t->sign = true;
}

void Expansion::signReverse()
{
	int first = result.rfind( "-" );
	int second = result.rfind( "+" );
	int where = ( second >= first) ? second : first;
	if (where < 0)
	{
		result.insert(0,"+");
		where = 0;
	}
	if ( result[where] == '-' ) result[where] = '+';
		else result[where] = '-';
}


void Expansion::signExpand( Tree* head)
{
	Tree* cur;
	queue<Tree*> Q_tree;
	Q_tree.push(head);
	while( Q_tree.size() != 0 )
	{
		cur = Q_tree.front();
		Q_tree.pop();
		if (cur != NULL) 
		{
			if ( (cur->data[0] != '*') && !isalpha(cur->data[0]) )
			{
				if(cur->sign) 
				{
					if (cur->left) cur->sign = false;
					changeSign(cur->left);
					changeSign(cur->right);
				}
				if(cur->data[0] == '-')
				{
					cur->data[0] = '+';
					changeSign(cur->right);
				}
			}
			Q_tree.push( cur->left  );
			Q_tree.push( cur->right );
		}
	}
}

void Expansion::infix(Tree * t)
{
	if(t == NULL)
		return;
	if(t->sign)
		signReverse();
	infix(t->left);
	result += t->data;
	infix(t->right);
}

void Expansion::checkPower( Tree* head)
{
	Tree* cur;
	queue<Tree*> Q_tree;
	Q_tree.push(head);
	while( Q_tree.size() != 0 )
	{
		cur = Q_tree.front();
		Q_tree.pop();
		if (cur != NULL) 
		{
			if ( cur->data[0] == '^' ) eliminatePower( cur );
			Q_tree.push( cur->left  );
			Q_tree.push( cur->right );
		}
		
	}
}
	
void naeem( string& str)
{
	int count = 0;
	while( count <= str.length() )
	{
		if ( str[count] == '*' )
		{
			if (! ( 
					(isalpha(str[count-1]) && isdigit(str[count+1])) 
				||	(isdigit(str[count-1]) && isdigit(str[count+1]))
				))
				str.erase( count, 1);
		}
		count++;
	}
}

string Expansion::sumOfProducts()
{
	int num = maxDepth( head );
	checkPower( head);
	for ( int i = 0; i < num; i++)
		PolyExpansion( head);
	signExpand( head);
	infix(head);
	naeem( result);
	return result;
}